// import contextual from "vue-cli-context";

// import vueConfigure from "./utils/vue-configure.js";
// import vueRunner from "./utils/vue-runner.js";
// import vueRegister from "./utils/vue-register.js";
// import vueStore from "./utils/vue-store.js";
// import vueRouter from "./utils/vue-router.js";
// import vueComponent from "./utils/vue-component.js";
// import vueStyle from "./utils/vue-style.js";
// import vueUtils from "./utils/vue-utils.js";
// import vueHttp from "./utils/vue-http.js";
// import vueI18N from "./utils/vue-i18n.js";
// import vueApi from "./utils/vue-api.js";
//
// const sniper = {
//   stores: {},
//   components: {},
//   routes: {},
//   styles: {},
//   utils: {},
//   i18n: {}
// };
//
// export default {
//   vueConfigure: vueConfigure(sniper),
//   vueRunner,
//   vueRegister,
//   vueStore: (Vuex, baseModule, configure = {}, modules = {}, getters = {}) =>
//     vueStore(
//       Vuex,
//       baseModule(configure.package),
//       Object.assign(modules, contextual(sniper.stores, false)),
//       getters
//     ),
//   vueRouter: (Router, baseRoutes, configure = {}) =>
//     vueRouter(Router, baseRoutes, contextual(sniper.routes, false), configure),
//   vueComponent: Prefix =>
//     vueComponent(Prefix, contextual(sniper.components, false)),
//   vueStyle: () => vueStyle(contextual(sniper.styles, false)),
//   vueUtils: dependencies =>
//     vueUtils(dependencies, contextual(sniper.utils, false)),
//   vueHttp,
//   vueI18N: (I18N, configure = {}) =>
//     vueI18N(I18N, contextual(sniper.i18n, false), configure),
//   vueApi
// };

// Import Action
import {
  support,
  registry,
  provider,
  procer,
  lint,
  fusion,
  attendant,
	taunt
} from "./action";

// Import Util
import {
  vueRunner,
  vueRegister,
  vueComponent,
  vueRouter,
  vueStore,
  vueLanguage
} from "./utils";

// Import Kit
import { http } from "./kit";

// Glober
const glober = {};

// Sniper
const sniper = {};

// Config
const config = {};

// External
function subscript(mode, hand) {
  // Treatment
  config[mode] = ["request", "response"].includes(mode) ? lint(mode) : {};

  // Get Surface
  sniper[mode] = hand(config[mode], sniper[mode]) || sniper[mode];
}

// Export
export default ({ Vue, Router, Vuex, I18N, Configure, Root }) => {
  return {
    // Structure
    Structure() {
      // Basic Support
      support(Vue, { Router, Vuex, I18N });

      // Procer Utils
      procer(sniper.util);

      // ★ Snipe Provider
      provider(process.env.rc || {}, sniper);

      // ★ Registry Provider
      registry(process.env.rc || {}, glober, sniper.util);

      // Api Hook External
      return {
        // Core
        Vue,
        // Model External
        subscript
      };
    },

    // Compile
    Compile(App) {
			// Taunt
			taunt(glober);

      // Fusion Debris
      fusion(glober, sniper);

      // Get Http
      const { request, response } = config;

      // Waiting Prototype
      const waitress = attendant(sniper, {
        $http: http(request, response)
      });

			console.log('waitress ::: ', waitress);

      // Util Register
      Vue.use(vueRegister, waitress);
      // Component Register
      Vue.use(vueComponent, sniper.component, { ...config.component });

      // Vue Runner
      Vue.use(vueRunner, App, {
        // Init Store
        store: vueStore(Vuex, sniper.store, waitress, glober.store),
        // Init Router
        router: vueRouter(Router, sniper.route, config.route, glober.route),
        // Init Language
        i18n: vueLanguage(I18N, sniper.i18n)
      });
    }
  };
};
